#Emma DiQuinzio
import time
import random

class State:
    def __init__(self, name, description, ):
        self.name = name
        self.description = description
        self.edges = []
        self.objects = []
        self.visted = False
        self.parent = None
       

class Edge:
    def __init__(self, name, from_node, commands, to_node, description, health, constraint=None):
        self.name = name
        self.from_node = from_node 
        self.commands = commands
        self.to_node = to_node
        self.description = description
        self.health = health
        self.constraint = constraint
        self.closed = False

class Object:
    def __init__(self, location, name, desc, description, weight = None):
        self.location = location
        self.name = name
        self.desc = desc
        self.description = description
        self.weight = weight
    def drop(self, new_loc):
        self.location = new_loc
        
class Constraint:
    def __init__(self, name, obj_name, obj_loc, weight = None):
        self.name = name
        self.obj_name = obj_name
        self.obj_loc = obj_loc
        self.weight = weight
        self.met = False

class Backpack:
    def __init__(self):
        self.objects = []
        self.weight = 0
    
class Engine:
    def __init__(self, filename):
        self.filename = filename
        self.initial_state = None
        self.count = 0
        self.health = 10
        self.time = time.time()
        self.constraints = []
        self.backpack = False
        self.backpack = Backpack()

    def load(self):
        self.states = {}
        edges = []
        objects = []
        fp = open(self.filename)
        for line in fp:
            if len(line) == 0 or line[0] == '#':
                continue
            items = line.strip().split("::")
            if items[0] == 'node':
                s = State(*items[1:])
                if self.initial_state is None:
                    self.initial_state = s
                self.states[items[1]] = s
            elif items[0] == 'edge':
                edges.append(Edge(*items[1:]))
            elif items[0] =='object':
                objects.append(Object(*items[1:]))
            elif items[0] =='backpack':
                self.backpack is True
                self.max_weight = int(item[2])
            elif items[0] == 'constraint':
                self.constraints.append(Constraint(*items[1:]))
        for edge in edges:
            self.states[edge.from_node].edges.append(edge)
        for obj in objects:
            self.states[obj.location].objects.append(obj)
            
    def met(self, constraint):#Checks to see if the constraint is met
        if constraint.obj_name == 'eval':
            print('eval')
            if eval(constraint.obj_loc) is True:
                constraint.met = True
                return constraint.met
        elif constraint.obj_name == 'exec':
            constraint.met = True
            exec(constraint.obj_loc)
        else:
            if constraint.obj_loc == 'backpack':
                objects = constraint.obj_name.split(', ')
                for obj in objects:
                    for obj in self.backpack.objects:
                        if obj.name in objects:
                            constraint.met = True
                            return constraint.met
            elif constraint.obj_loc in self.states:
                for obj in self.states[constraint.obj_loc].objects:
                    if obj.name is objects:
                        constraint.met = True
                        return constraint.met
                    
    def play(self):
        current_state = self.initial_state
        while True:
            print(current_state.description)
            command = input("Command> ")
            c = command.split()
            for edge in current_state.edges:
                if command in edge.commands:
                    if edge.constraint is not None:#checks the return of met and proceeds depending on the result
                        edge.closed = True
                        for constraint in self.constraints:
                            if constraint.name in edge.constraint:
                                self.met(constraint)
                                if constraint.met is True:
                                    edge.closed = False
                                    current_state = self.states[edge.to_node]
                                    print(edge.description)
                                    self.count += 1
                                    self.health += int(edge.health)
                                    timer = time.time() - self.time
                                elif constraint.met is False:
                                    edge.closed = True
                                    print("Not yet.")
                    else:#if there is no constraint
                        current_state = self.states[edge.to_node]
                        print(edge.description)
                        self.count +=1
                        self.health += int(edge.health)
                        timer = time.time() - self.time
            for obj in current_state.objects:
                if c[0] == 'get':#adds objects to backpack list and revomoves it from current state 
                    if c[1] in obj.name:
                        obj.location = 'backpack'
                        self.backpack.objects.append(obj)
                        current_state.objects.remove(obj)
                        print("You placed the", obj.name,"in your backpack")
                if c[0] in obj.name:
                    print(obj.desc)
                if c[0] =='look':
                    if c[1] in obj.name:
                        print(obj.description)
            for obj in self.backpack.objects:
                c = command.split()
                if c[0] == 'backpack':
                    print(obj.desc)
                if c[0] == 'drop':#removes objects from backpack and appends it to surrent state
                    if c[1] in obj.name:
                        obj.location = current_state.name
                        current_state.objects.append(obj)
                        self.backpack.objects.remove(obj)
                        print("You dropped the", obj.name)
            if c[0] == 'packpack':#Zombie in my code, but it doesn't affect anything else
                print("you put your packpack on your tauntaun.  However, your tauntaun isn't moving, maybe you should stick with backpacks, and carry them yourself, you're not a Jedi")
            if self.health <=0 :#checks health and ends game.
                print("Your health has dropped too low.  Game Over.")
                an = input("try again? [yes/no]")
                if an == 'yes':
                    self.health = 10
                    game.play()
                else:
                    print("Good Bye!")
                return
            if self.count <=100:#checks count and ends the game
                print("You have taken too many turns.  Game Over.")
                an = input("try again? [yes/no].")
                if an == 'yes':
                    self.count = 0
                    game.play()
                else::
                    print("Good Bye!")
                    return
                break


     
game = Engine("WITCH.txt")
game.load()
game.play()


